<template>
  <header-title v-if="allowTheme" :title="$t('bet_history')" />
  <div class="w-full relative h-full flex justify-center items-center" v-if="availableTabs.length <= 0">
    <utils-not-found />
  </div>
  <template v-else>
    <div class="peru-tab flex flex-col bet-history-cotnainer" v-if="themeName === 'peru'">
      <el-tabs v-model="activeTab" :class="`bet-history-game-type-tab ${selectedThemeName} peru-sport-betting-box`">
        <div class="setting-tab">
          <div class="flex flex-row gap-0.5 inputElement">
            <div :class="isSportType ? 'w-1/3' : 'w-1/2'">
              <el-select
                @focus="onSelectFocus"
                v-model="selectedProvider"
                class="w-full font-bold"
                :suffix-icon="IconDropDownArrow"
                :disabled="
                  disableSelect || (popperActive && popperActive !== 'provider')
                "
                @change="onMobileFilterChange"
                :popper-class="`select-bet-history ${selectedThemeName}`"
                @visible-change="onVisibleChange($event, 'provider')"
              >
                <el-option
                  v-for="provider in gameProviders"
                  :key="provider.GameProviderName"
                  :label="provider.GameProviderName"
                  :value="provider.GameProviderId"
                >
                  <div class="flex justify-between w-full">
                    <div class="flex items-center">
                      <div>
                        {{ provider.GameProviderName }}
                      </div>
                      <div
                        v-if="themeColor.Text === 'bk8'"
                        class="w-[16px] ml-[11px] currency-check-icon hidden"
                      >
                        <font-awesome-icon icon="circle-check" />
                      </div>
                    </div>
                  </div>
                </el-option>
              </el-select>
            </div>
            <div v-show="isSportType" class="w-1/3">
              <el-select
                @focus="onSelectFocus"
                v-model="selectedSportStatus"
                :suffix-icon="IconDropDownArrow"
                :disabled="popperActive && popperActive !== 'status'"
                class="w-full font-bold"
                @change="onMobileFilterChange"
                :popper-class="`select-bet-history ${selectedThemeName}`"
                @visible-change="onVisibleChange($event, 'status')"
              >
                <el-option
                  v-for="(item, index) in allSportStatus"
                  :key="index"
                  :label="item"
                  :value="item"
                >
                  <div class="flex justify-between w-full">
                    <div class="flex items-center">
                      <div>
                        {{ item }}
                      </div>
                      <div
                        v-if="themeColor.Text === 'bk8'"
                        class="w-[16px] ml-[11px] currency-check-icon hidden"
                      >
                        <font-awesome-icon icon="circle-check" />
                      </div>
                    </div>
                  </div>
                </el-option>
              </el-select>
            </div>
            <date-picker-datetime-range-selector-mobile
              class="select-date-mobile-component"
              :class="isSportType ? 'w-1/3' : 'w-1/2'"
              v-model:startDate="selectedStartDate"
              v-model:endDate="selectedEndDate"
              :onClickSearch="onSearch"
              :disabled="
                (selectedSportStatus === 'Running' && isSportType) ||
                (popperActive && popperActive !== 'date')
              "
              :number-date-for-disable="60"
              :onSelectDropDownClick="isShowDatePickerPanel"
              @visible-change="onVisibleChange($event, 'date')"
            />
          </div>
        </div>
        <el-tab-pane :label="$t('sports')" :name="BET_HISTORY_TAB.SPORT"
          v-if="availableTabs.includes('sports')">
          <lazy-mobile-bet-details-sport-bet
            v-loading="isLoading"
            :is-settled="isSettled"
            :sport-bet="sportBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane
          :label="$t('virtual_sports')"
          :name="BET_HISTORY_TAB.VIRTUAL_SPORT"
          v-if="availableTabs.includes('virtual_sports')"
        >
          <lazy-mobile-bet-details-sport-bet
            v-loading="isLoading"
            :is-settled="isSettled"
            :sport-bet="sportBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('live_casino')" :name="BET_HISTORY_TAB.CASINO"
          v-if="availableTabs.includes('live_casino')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('games')" :name="BET_HISTORY_TAB.GAME_BET"
          v-if="availableTabs.includes('games')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('cock_fight')" :name="BET_HISTORY_TAB.COCKFIGHT"
          v-if="availableTabs.includes('cock_fight')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('poker')" :name="BET_HISTORY_TAB.POKER"
          v-if="availableTabs.includes('poker')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('lottery')" :name="BET_HISTORY_TAB.LOTTERY"
          v-if="availableTabs.includes('lottery')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
      </el-tabs>
    </div>
    <div class="flex flex-col bg-background2 bet-history-cotnainer" v-else>
      <el-tabs v-model="activeTab" :class="`bet-history-game-type-tab ${selectedThemeName}`">
        <div class="bg5-L1350 h-[2px]"></div>
        <div class="bg-background2 setting-tab">
          <div class="flex flex-row gap-0.5 inputElement">
            <div :class="isSportType ? 'w-1/3' : 'w-1/2'">
              <el-select
                v-model="selectedProvider"
                class="w-full font-bold"
                :suffix-icon="IconDropDownArrow"
                :disabled="
                  disableSelect || (popperActive && popperActive !== 'provider')
                "
                @change="onMobileFilterChange"
                :popper-class="`select-bet-history ${selectedThemeName}`"
                @focus="onSelectFocus"
                @visible-change="onVisibleChange($event, 'provider')"
              >
                <el-option
                  v-for="provider in gameProviders"
                  :key="provider.GameProviderName"
                  :label="provider.GameProviderName"
                  :value="provider.GameProviderId"
                >
                  <div class="flex justify-between w-full">
                    <div class="flex items-center">
                      <div>
                        {{ provider.GameProviderName }}
                      </div>
                      <div
                        v-if="themeColor.Text === 'bk8'"
                        class="w-[16px] ml-[11px] currency-check-icon hidden"
                      >
                        <font-awesome-icon icon="circle-check" />
                      </div>
                    </div>
                  </div>
                </el-option>
              </el-select>
            </div>
            <div v-show="isSportType" class="w-1/3">
              <el-select
                v-model="selectedSportStatus"
                class="w-full font-bold"
                :suffix-icon="IconDropDownArrow"
                :disabled="popperActive && popperActive !== 'status'"
                @change="onMobileFilterChange"
                :popper-class="`select-bet-history ${selectedThemeName}`"
                @focus="onSelectFocus"
                @visible-change="onVisibleChange($event, 'status')"
              >
                <el-option
                  v-for="(item, index) in allSportStatus"
                  :key="index"
                  :label="item"
                  :value="item"
                >
                  <div class="flex justify-between w-full">
                    <div class="flex items-center">
                      <div>
                        {{ item }}
                      </div>
                      <div
                        v-if="themeColor.Text === 'bk8'"
                        class="w-[16px] ml-[11px] currency-check-icon hidden"
                      >
                        <font-awesome-icon icon="circle-check" />
                      </div>
                    </div>
                  </div>
                </el-option>
              </el-select>
            </div>
            <date-picker-datetime-range-selector-mobile
              class="select-date-mobile-component"
              :class="isSportType ? 'w-1/3' : 'w-1/2'"
              v-model:startDate="selectedStartDate"
              v-model:endDate="selectedEndDate"
              :onClickSearch="onSearch"
              :disabled="
                (selectedSportStatus === 'Running' && isSportType) ||
                (popperActive && popperActive !== 'date')
              "
              :number-date-for-disable="60"
              :onSelectDropDownClick="isShowDatePickerPanel"
              @visible-change="onVisibleChange($event, 'date')"
            />
          </div>
        </div>
        <el-tab-pane :label="$t('sports')" :name="BET_HISTORY_TAB.SPORT" v-if="availableTabs.includes('sports')">
          <lazy-mobile-bet-details-sport-bet
            v-loading="isLoading"
            :is-settled="isSettled"
            :sport-bet="sportBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane
          :label="$t('virtual_sports')"
          :name="BET_HISTORY_TAB.VIRTUAL_SPORT"
          v-if="availableTabs.includes('virtual_sports')">
          <lazy-mobile-bet-details-sport-bet
            v-loading="isLoading"
            :is-settled="isSettled"
            :sport-bet="sportBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('live_casino')" :name="BET_HISTORY_TAB.CASINO" v-if="availableTabs.includes('live_casino')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('games')" :name="BET_HISTORY_TAB.GAME_BET"
          v-if="availableTabs.includes('games')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('cock_fight')" :name="BET_HISTORY_TAB.COCKFIGHT"
          v-if="availableTabs.includes('cock_fight')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('poker')" :name="BET_HISTORY_TAB.POKER"
          v-if="availableTabs.includes('poker')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
        <el-tab-pane :label="$t('lottery')" :name="BET_HISTORY_TAB.LOTTERY"
          v-if="availableTabs.includes('lottery')">
          <lazy-mobile-bet-details-game-bet
            v-loading="isLoading"
            :game-bet-list="gameBetListDisplay"
            :on-display-bet-detail="onDisplayBetDetail"
          />
        </el-tab-pane>
      </el-tabs>
    </div>
    <el-backtop :right="10" :bottom="10">
      <div
        class="bg-secondary w-[32px] h-[32px] flex items-center justify-center rounded"
      >
        <font-awesome-icon class="text-white" icon="arrow-up" />
      </div>
    </el-backtop>
  </template>
</template>

<script lang="ts">
import { computed, defineComponent, ref, watch } from "vue";
import _ from "lodash";
import HeaderTitle from "@/components/new-black-theme/m-header-title.client.vue";
import IconDropDownArrow from "@/components/icon/DropDownArrow.client.vue";
import { ISportBet, SportBet } from "@/models/sportbet/sportbet";
import { ISeamlessGameBet, SeamlessGameBet } from "@/models/seamlessGameBets";
import { store } from "~~/store";

export default defineComponent({
  name: "BetHistory",
  components: {
    HeaderTitle,
  },
  setup() {
    const {
      activeTab,
      isLoading,
      sportBetList,
      selectedProvider,
      gameProviders,
      gameBetList,
      selectedSportStatus,
      allSportStatus,
      selectedStartDate,
      selectedEndDate,
      onSearch,
      isSportType,
      currentPage,
      disableSelect,
      onDisplayBetDetail,
      isSettled,
      allTabs,
    } = useBetHistory();
    const selectedThemeName = store.state.selectedThemeName;
    const isShowDatePickerPanel = ref(false);
    const gameBetByPaging = ref([] as ISeamlessGameBet[]);
    const sportBetByPaging = ref([] as ISportBet[]);
    const onSelectFocus = (...e) => {
      if(isShowDatePickerPanel.value) {
        isShowDatePickerPanel.value = false;
      } else {
        isShowDatePickerPanel.value = true;
      }
    };
    const sportMaxPage = computed(
      () => _.first(sportBetList.value)?.MaxPage ?? 0
    );
    const gameMaxPage = computed(
      () => _.first(gameBetList.value)?.MaxPage ?? 0
    );
    watch(activeTab, () => {
      window.scrollTo(0, 0);
      sportBetByPaging.value = [];
      gameBetByPaging.value = [];
      currentPage.value = 1;
    });
    const onMobileFilterChange = () => {
      window.scrollTo(0, 0);
      sportBetByPaging.value = [];
      gameBetByPaging.value = [];
      currentPage.value = 1;
      onSearch();
    };

    window.onscroll = function () {
      const scrollTop =
        document.documentElement.scrollTop || document.body.scrollTop;
      const windowHeight =
        document.documentElement.clientHeight || document.body.clientHeight;
      const scrollHeight =
        document.documentElement.scrollHeight || document.body.scrollHeight;
      if (
        scrollTop + windowHeight === scrollHeight ||
        scrollHeight - (scrollTop + windowHeight) < 1
      ) {
        const maxPage = isSportType.value
          ? sportMaxPage.value
          : gameMaxPage.value;
        if (maxPage > currentPage.value) {
          currentPage.value += 1;
        }
      }
    };
    watch(sportBetList, () => {
      sportBetByPaging.value = sportBetByPaging.value.concat(
        sportBetList.value
      );
    });
    watch(gameBetList, () => {
      gameBetByPaging.value = gameBetByPaging.value.concat(gameBetList.value);
    });
    const arrayTheme = ["main", "black", "sbo", 'global', 'playful'];
    const allowTheme = computed(() =>
      arrayTheme.includes(store.state.selectedThemeName)
    );
    const sportBetListDisplay = computed(() =>
      sportBetList.value.map((sb) => new SportBet(sb))
    );
    const gameBetListDisplay = computed(() =>
      gameBetList.value.map((gb) => new SeamlessGameBet(gb))
    );
    const { themeColor } = themePropertyHelper;
    const themeName = store.state.selectedThemeName;
    const availableTabs = computed(()=>allTabs.value.map((tabInfo) => tabInfo.TabLanguage));
    const popperActive = ref<"provider" | "status" | "date">();
    const onVisibleChange = (
      show: boolean,
      type: "provider" | "status" | "date"
    ) => {
      if (show) {
        popperActive.value = type;
      } else {
        popperActive.value = undefined;
      }
    };
    return {
      popperActive,
      activeTab,
      isLoading,
      selectedProvider,
      gameProviders,
      selectedSportStatus,
      allSportStatus,
      selectedStartDate,
      selectedEndDate,
      isSportType,
      sportBetByPaging,
      gameBetByPaging,
      onMobileFilterChange,
      onDisplayBetDetail,
      disableSelect,
      allowTheme,
      sportBetListDisplay,
      gameBetListDisplay,
      isSettled,
      themeColor,
      themeName,
      availableTabs,
      onSearch,
      IconDropDownArrow,
      selectedThemeName,
      onSelectFocus,
      isShowDatePickerPanel,
      onVisibleChange,
    };
  },
});
</script>
<style scoped lang="postcss">
:deep(.el-tabs__header) {
  @apply fixed w-full px-5;
  z-index: 10;
  background: var(--background1);
}
:deep(.el-tabs__content) {
  @apply pt-3;
  margin-top: 105px;
}
:deep(.el-tabs__nav-wrap::after) {
  height: 0px;
}
:deep(.el-tabs__nav-wrap.is-scrollable) {
  @apply px-0;
}
.setting-tab {
  @apply fixed w-full;
  z-index: 10;
  top: 84px;
}
.el-tabs__nav-next,
.el-tabs__nav-prev {
  display: none;
}

:deep(.el-tabs__nav-scroll) {
  overflow-x: auto;
}
:deep(.el-tabs__nav-next) {
  display: none;
}
:deep(.el-tabs__nav-prev) {
  display: none;
}
.el-backtop {
  background-color: transparent;
  box-shadow: none;
}
:deep(.el-input__wrapper) {
  width: 100%;
}
.selected .currency-check-icon {
  display: block !important;
}
</style>
<style lang="scss">
[layout="modern"] .el-tabs__header {
  top: 0;
}
[theme-color="bk8"] .el-select .el-input .el-select__caret{
  color: var(--text) !important;
  stroke: black;
  stroke-width: 70;
}
[layout="playful"] .bg-background2 .el-tabs__header {
  @apply fixed w-full;
  z-index: 10;
  padding-right: 8px !important;
  padding-left: 8px !important;
  background: var(--background1);
}
@media (max-width: 639px) {
  .peru-tab .el-tabs__nav {
    height: 45px;
  }
  .peru-tab .el-tabs__header.is-top {
    position: relative;
    padding: 5px 20px;
  }
  .peru-tab .el-tabs__header.is-top:before {
    background: #505451;
    bottom: 4px;
    content: "";
    height: 2px;
    left: 0;
    position: absolute;
    width: 100%;
  }
}
.bet-history-game-type-tab {
  .el-tabs__item.is-active {
    color: var(--primary) !important;
    border-bottom: 4px solid;
  }
  .el-tabs__active-bar {
    display: none;
  }
  .el-input__inner {
    background: var(--background5);
    border-radius: unset;
    box-shadow: unset;
  }
  .el-select {
    .el-input.is-focus {
      .el-input__inner {
        box-shadow: unset !important;
      }
    }
  }
  .el-tabs__header {
    background: var(--background5);
  }
  .el-select:hover:not(.el-select--disabled) {
    .el-input__inner {
      box-shadow: none;
    }
  }
  .select-date-mobile-component {
    display: flex;
    .el-date-editor .el-range-input {
      color: var(--text5);
    }
  }
  &.modern {
    .setting-tab {
      padding-top: 20px;
    }
    .el-input__inner {
      height: 48px;
    }
  }
  &.peru {
    .el-input__inner {
      height: 48px;
    }
    .el-input__wrapper {
      border: 1px solid var(--border);
    }
  }
}
.select-bet-history {
  inset: 152px auto auto auto !important;
  width: 100vw;
  .el-popper__arrow::before {
    position: unset;
  }
  ul {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    gap: 8px;
    margin: 8px !important;
    li.selected {
      background: var(--background5);
      border-radius: 4px;
      div > div::before {
        content: ""; /* Required for pseudo-elements, but doesn't generate any content */
        height: 14px;
        width: 2px;
        background-color: var(--primary);
        margin-right: 10px; /* Optional margin between the injected div and the target div */
      }
    }
    li {
      background: var(--background5);
      border-radius: 4px;
    }
  }
  .el-select-dropdown__item.hover {
    background-color: var(--background5);
  }
  &.el-select__popper {
    &.china {
      inset: 118px auto auto auto !important;
    }
    &.modern {
      inset: 114px auto auto auto !important;
    }
    &.playful {
      inset: 162px auto auto auto !important;
    }
    &.peru {
      inset: 180px auto auto auto !important;
    }
  }
}
.bet-history-game-type-tab {
  .el-tabs__item.is-active {
    color: var(--primary) !important;
    border-bottom: 4px solid;
  }
  .el-tabs__item, .el-input__inner {
    color: var(--text5) !important;
  }
  .el-tabs__active-bar {
    display: none;
  }
  .el-input__inner {
    background: var(--background5);
    border-radius: unset;
    box-shadow: unset;
  }
  .el-select {
    .el-input.is-focus {
      .el-input__inner {
        box-shadow: unset !important;
      }
    }
  }
  .el-tabs__header {
    background: var(--background5);
  }
  .el-select:hover:not(.el-select--disabled) {
    .el-input__inner {
      box-shadow: none;
    }
  }
  .select-date-mobile-component {
    display: flex;
  }
}
.select-bet-history {
  inset: 152px auto auto auto !important;
  width: 100vw;
  .el-popper__arrow::before {
    position: unset;
  }
  ul {
    display: grid;
    grid-template-columns: repeat(2, 1fr);
    gap: 8px;
    margin: 8px !important;
    li.selected {
      background: var(--background5);
      border-radius: 4px;
      div > div::before {
        content: ""; /* Required for pseudo-elements, but doesn't generate any content */
        height: 14px;
        width: 2px;
        background-color: var(--primary);
        margin-right: 10px; /* Optional margin between the injected div and the target div */
      }
    }
    li {
      background: var(--background5);
      border-radius: 4px;
    }
  }
  .el-select-dropdown__item.hover {
    background-color: var(--background5);
  }
  .el-select-dropdown__item {
    color: var(--text5) !important;
  }
}
.bet-history-cotnainer {
  .el-tabs {
    .el-tabs__header.is-top {
      padding-left: 0;
      padding-right: 0;
    }
    .el-tabs__nav-wrap.is-top {
      padding-left: 0;
      padding-right: 0;
    }
  }
  .el-tabs--top .el-tabs__item.is-top:nth-child(2) {
    padding-left: 14px;
  }
  .el-tabs__item.is-top:last-child {
    padding-right: 14px;
  }
  .peru-sport-betting-box .el-tabs__content {
    padding-top: 0px;
  }
}
</style>
